#ifndef ROBOT_H
#define ROBOT_H


#include "common.h"


#define GRID_SIZE	0.35
#define CLOTH_WIDTH	21
#define CLOTH_HEIGHT	21
#define NUM_SQUARES	(CLOTH_WIDTH-1)*(CLOTH_HEIGHT-1)
#define NUM_TRIANGLES	NUM_SQUARES*2
#define NUM_INDICES	NUM_TRIANGLES*3


extern float gravity[3];
extern float ks;
extern float kd;
extern int   stiffness;

extern float windvec[3];

extern bool  anchor;
extern bool  sphere;
extern bool  wind;
extern bool  internal;

extern float cloth_vertices[CLOTH_HEIGHT*CLOTH_WIDTH*3];
extern float cloth_velocities[CLOTH_HEIGHT*CLOTH_WIDTH*3];
extern float cloth_colors[CLOTH_HEIGHT*CLOTH_WIDTH*3];


void initCloth();
void drawCloth();
void updateCloth();

bool anchored(int i, int j);

void internalCollision (int index);
void floorCollision (int index);
void sphereCollision (int index);


typedef struct {
  int   v[3];
  float n[3];
  float m;
} triangle;

#endif // ROBOT_H
