#include "vector.h"

#include <iostream>


void vectorAddV (float a[3], const float x, const float b[3], 
                 const float y, const float c[3])
{
  for (int i = 0; i < 3; i++)
      a[i] = x*b[i] + y*c[i];
}
 

void vectorAddS (float a[3], const float x, const float b[3], 
                 const float y)
{
  for (int i = 0; i < 3; i++)
      a[i] = x*b[i] + y;
}
 

void vectorMult (float a[3], const float x, const float b[3])
{
  for (int i = 0; i < 3; i++)
      a[i] = x*b[i];
}
     

void vectorMag (float* m, const float v[3])
{
  *m = sqrt(sqr(v[0]) + sqr(v[1]) + sqr(v[2]));
}


void vectorUnit (float a[3], const float b[3])
{
  float m;
  vectorMag(&m, b);
  if (m == 0)
      cerr << "zero-length spring!" << endl;
  else
      vectorMult(a, 1/m, b);
}


void vectorSet (float a[3], const float x)
{
  for (int i = 0; i < 3; i++)
      a[i] = x;
}


void vectorCopy (float a[3], const float b[3])
{
  for (int i = 0; i < 3; i++)
      a[i] = b[i];
}


void vectorDot (float* a, const float b[3], const float c[3])
{
  *a = b[0]*c[0] + b[1]*c[1] + b[2]*c[2];
}


void vectorCross (float a[3], const float b[3], const float c[3])
{
  a[0] =  b[1]*c[2] - b[2]*c[1];
  a[1] = -b[0]*c[2] + b[2]*c[0];
  a[2] =  b[0]*c[1] - b[1]*c[0];
}
